<template>
    <div>
        <form @submit.prevent="onSubmit">
            <div class="form-group col-md-6" :class="{'has-error': this.errors_unities.name}">
                <label>Nome<b class="text-danger">*</b></label>
                <input type="text" class="form-control" v-model.lazy="formData.name">
                <label class="error" v-if="this.errors_unities.name">{{this.errors_unities.name[0]}}</label>
            </div>

            <div class="form-group col-md-6" :class="{'has-error': this.errors_unities.sigla}">
                <label>Sigla<b class="text-danger">*</b></label>
                <input type="text" class="form-control" v-model="formData.sigla">
                <label class="error" v-if="this.errors_unities.sigla">{{this.errors_unities.sigla[0]}}</label>
            </div>

            <div class="col-sm-12">
                <div class="hr-line-dashed"></div>
                <button class="btn btn-white" type="button" @click.prevent="backPage" :disabled="isBtnPreload">
                    <i class="fa fa-reply"></i> Voltar
                </button>
                <button class="btn btn-primary" type="submit" :disabled="isBtnPreload">
                    <i v-if="isBtnPreload" class="fa fa-circle-o-notch fa-spin"></i>
                    <i class="fa fa-save" v-else></i>
                    Salvar
                </button>
            </div>
        </form>
    </div>
</template>

<script>
    export default {
        props: {
            isUpdate: {
                require: false,
                type: Boolean,
                default: false,
            },

            formData: {
                require: false,
                type: Object,
                default: () => {
                    return {
                        name: '',
                        sigla: '',
                    }
                }
            }
        },
        data() {
            return {
                errors_unities: {
                    name: '',
                    sigla: '',
                }
            }
        },

        computed: {
            isBtnPreload() {
                return this.$store.state.preload.btnLoading
            }
        },

        methods: {
            onSubmit() {
                const action = this.isUpdate ? 'updateUnity' : 'storeUnity'
                const msg = this.isUpdate ? 'Unidade de medida editada com sucesso' :
                    'Cadastro de unidade de medida feita com sucesso'
                this.$store.dispatch(action, this.formData)
                    .then(() => {
                        this.$snotify.success(msg)
                        this.resetFormData()
                        this.$router.push({name: 'unities'})
                    })
                    .catch((error) => {
                        this.errors_unities = error.response.data.errors
                    })
            },

            resetFormData() {
                this.formData = {
                    name: '',
                    sigla: ''
                }
            },

            backPage() {
                return this.$router.push({name: 'unities'})
            }
        }
    }
</script>